#define VENTRY_NUMBER 64
#define H_VAR_NUMBER 4096
#define ID_VARIANTSTART 1000
#define LEFT_MAX (VENTRY_NUMBER/2-1)
#define RIGHT_START VENTRY_NUMBER/2
#define ID_MENUABOUT 10
#define ID_MENUINFO 11
#define ID_MENUHOTKEYS 12

class SingleVisualEntry2
    {
    public:
	SingleVisualEntry2();
	int qNumber;
	RECT task;
	RECT variants;
	HWND hVariant[H_VAR_NUMBER];
	HWND hOK;
	bool visible;
    };

class Screen2
    {
    public:
    RECT rMainWindow;
    SingleVisualEntry2 Entry[VENTRY_NUMBER];
    HINSTANCE hInst;
    HWND hWnd;
    HWND hOwned;
    HFONT hCorrect,hMissing,hExcessive;
    int CurrentPosition;
    int nID;
    bool bFirst;
    bool bOK;
    int tmAveCharWidth;
    float fChar_test;
    void Init();
    void InsertPosition(int nPosition);
    void HideAll();
    void RemoveInvisible();
    void Cleaner();
    void Anounce(WPARAM wParam);
    bool CreateMenuItem(HMENU hMenu,char* str,UINT uID,UINT wID,HMENU hSubMenu);
    Screen2();
    };

Screen2::Screen2()
    {
    bFirst=1;
    bOK=1;
    int nID=ID_VARIANTSTART-1;
    CurrentPosition=-1;
//    TEXTMETRIC tmTM;
//    GetClientRect(hWnd,&rMainWindow);
//    HDC hDC=GetDC(hWnd);
//    GetTextMetrics(hDC,&tmTM);
//    tmAveCharWidth=tmTM.tmAveCharWidth;
//    fChar_test=rMainWindow.right/2;
//    fChar_test=fChar_test/tmAveCharWidth;
//    ReleaseDC(hWnd,hDC);
    }

void Screen2::Anounce(WPARAM wParam)
    {
    if(LOWORD(wParam)==ID_MENUABOUT)
    {
    char s[]="Программа для подготовки к тестированию \"AskMe 2.0\".\nДомашняя страница: http://mmaketchup.narod.ru/additional.htm\nПрограмма распространяется по лицензии GPL\nПожелания и предложения напрявляйте на e-mail: mmaketchup@mail.ru.\n\nАвтор - Ketchup.\nСентябрь 2006.";
    MessageBox(hWnd,s,"О программе",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
    }
    if(LOWORD(wParam)==ID_MENUHOTKEYS)
    {
    char s[]="Для выбора ответа используйте клавиши 1-7 на дополнительной (включите NumLock) или основной клавиатуре\nНажать кнопку \"OK\" можно пробелом или \"Enter\"";
    MessageBox(hWnd,s,"Горячие клавиши",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
    }
    if(LOWORD(wParam)==ID_MENUINFO)
    {
    char s[]="Формат базы:\nКаждый вопрос состоит из задания и вариантов ответа. На задание и варианты отводится по 1 строчке. Перед каждым вариантом стоит символ табуляции: (char)9\nКаждая дисциплина расположена в отдельной директории.\nОписание содержимого директории находится в файле \"Base\\x.txt\", где x - порядковый номер дисциплины\nВ файле-описании первая строчка отведена под название дисциплины. Далее идут строчки описания следующего формата: символ табуляции, затем название темы, далее в кавычках относительный путь к файлу с вопросами темы\nКодировка всех файлов: Windows-1251";
    MessageBox(hWnd,s,"Информация",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
    }
    }

void Screen2::Init()
    {
    TEXTMETRIC tmTM;
    int nID=ID_VARIANTSTART-1;
    CurrentPosition=-1;
    GetClientRect(hWnd,&rMainWindow);
    HDC hDC=GetDC(hWnd);
    GetTextMetrics(hDC,&tmTM);
    tmAveCharWidth=tmTM.tmAveCharWidth;
    fChar_test=rMainWindow.right/2;
    fChar_test=fChar_test/tmAveCharWidth;
    ReleaseDC(hWnd,hDC);
    hCorrect=CreateFont(
	0,			// height of font
	0,			// average character width
	0,			// angle of escapement
	0,			// base-line orientation angle
	700,			// font weight
	0,			// italic attribute option
	0,			// underline attribute option
	0,			// strikeout attribute option
	OEM_CHARSET,		// character set identifier
	OUT_DEFAULT_PRECIS,	// output precision
	CLIP_DEFAULT_PRECIS,	// clipping precision
	DEFAULT_QUALITY,	// output quality
	DEFAULT_PITCH,		// pitch and family
	NULL			// typeface name
	);
    hMissing=CreateFont(
	0,			// height of font
	0,			// average character width
	0,			// angle of escapement
	0,			// base-line orientation angle
	700,			// font weight
	0,			// italic attribute option
	1,			// underline attribute option
	0,			// strikeout attribute option
	OEM_CHARSET,		// character set identifier
	OUT_DEFAULT_PRECIS,	// output precision
	CLIP_DEFAULT_PRECIS,	// clipping precision
	DEFAULT_QUALITY,	// output quality
	DEFAULT_PITCH,		// pitch and family
	NULL			// typeface name
	);
    hExcessive=CreateFont(
	0,			// height of font
	0,			// average character width
	0,			// angle of escapement
	0,			// base-line orientation angle
	400,			// font weight
	0,			// italic attribute option
	0,			// underline attribute option
	1,			// strikeout attribute option
	OEM_CHARSET,		// character set identifier
	OUT_DEFAULT_PRECIS,	// output precision
	CLIP_DEFAULT_PRECIS,	// clipping precision
	DEFAULT_QUALITY,	// output quality
	DEFAULT_PITCH,		// pitch and family
	NULL			// typeface name
	);
    }

void Screen2::InsertPosition(int nPosition)
    {
    int nStart;
    if(nPosition<LEFT_MAX) nStart=LEFT_MAX;
    else if(nPosition>RIGHT_START) nStart=VENTRY_NUMBER-1;
    else nStart=0;
    for(int i=nStart;i>nPosition;i--)
	{
        Entry[i].qNumber=Entry[i-1].qNumber;
        Entry[i].task=Entry[i-1].task;
        Entry[i].variants=Entry[i-1].variants;
        Entry[i].visible=Entry[i-1].visible;
        for(int j=0;j<VAR_NUMBER;j++) {Entry[i].hVariant[j]=Entry[i-1].hVariant[j];}
        Entry[i].hOK=Entry[i-1].hOK;
	}
    for(int j=0;j<VAR_NUMBER;j++) {Entry[nPosition].hVariant[j]=NULL;}
    Entry[nPosition].hOK=NULL;
    }

bool Screen2::CreateMenuItem (HMENU hMenu,char* str,UINT uID,UINT wID,HMENU hSubMenu)
    {
    MENUITEMINFO mi;
    mi.cbSize = sizeof(MENUITEMINFO);
    mi.fMask = MIIM_STATE|MIIM_TYPE|MIIM_SUBMENU|MIIM_ID;
    mi.fType = MFT_STRING;
    mi.fState = MFS_ENABLED;
    mi.dwTypeData = str;
    mi.cch = sizeof(str);
    mi.wID = wID;
    mi.hSubMenu = hSubMenu;
    return InsertMenuItem(hMenu, uID, FALSE, &mi);
    }

SingleVisualEntry2::SingleVisualEntry2()
    {
	for(int i=0;i<VAR_NUMBER;i++) hVariant[i]=NULL;
	hOK=NULL;
	qNumber=-1;
	task.left=0;
	task.right=0;
	task.top=0;
	task.bottom=0;
	variants.left=0;
	variants.right=0;
	variants.top=0;
	variants.bottom=0;
	visible=FALSE;
    }

void Screen2::HideAll()
    {
    for(int i=0;i<VENTRY_NUMBER;i++) {Entry[i].visible=FALSE;}
    CurrentPosition=-1;
    }

void Screen2::RemoveInvisible()
    {
    for(int i=0;i<VENTRY_NUMBER;i++)
    {
	if((!Entry[i].visible)&(Entry[i].qNumber!=-1))
	{
//	InvalidateRect(hWnd, &Entry[i].task,1);
	InvalidateRect(hWnd, &Entry[i].task,1);
	for(int j=0;j<VAR_NUMBER;j++)
	    {
	    if(Entry[i].hVariant[j]!=NULL) {DestroyWindow(Entry[i].hVariant[j]);Entry[i].hVariant[j]=NULL;}
	    }
	}
	if(i!=CurrentPosition)
	{
	if(Entry[i].hOK!=NULL) {DestroyWindow(Entry[i].hOK);Entry[i].hOK=NULL;}
	}
	UpdateWindow(hWnd);
    }
    }

void Screen2::Cleaner()
    {
    HWND hWndFind;
    do
    {
        hWndFind=GetWindow(hWnd,GW_CHILD);
        if(hWndFind!=NULL) {DestroyWindow(hWndFind);}
    }
    while(hWndFind!=NULL);
    }
